#include "Matrix.h"

#include <iostream>
using namespace std;
#include <string>
#include <sstream>

////////////////////////////////////////////////////////////////////////////////
std::string & arda::Matrix::getstring2m(Matrix2i m, std::string & s)
   {
   s.clear();
   std::stringstream ss;
   ss << "[ "
	 "[ " << m[0] << ", " << m[1] << " ], "
	 "[ " << m[2] << ", " << m[3] << " ] ]";
   s = ss.str();
   return s;   
   }

////////////////////////////////////////////////////////////////////////////////
std::string & arda::Matrix::getstring2m(Matrix2f m, std::string & s)
   {
   s.clear();
   std::stringstream ss;
   ss << "[ "
	 "[ " << m[0] << ", " << m[1] << " ], "
	 "[ " << m[2] << ", " << m[3] << " ] ]";
   s = ss.str();
   return s;   
   }

////////////////////////////////////////////////////////////////////////////////
std::string & arda::Matrix::getstring2m(Matrix2d m, std::string & s)
   {
   s.clear();
   std::stringstream ss;
   ss << "[ "
	 "[ " << m[0] << ", " << m[1] << " ], "
	 "[ " << m[2] << ", " << m[3] << " ] ]";
   s = ss.str();
   return s;   
   }

////////////////////////////////////////////////////////////////////////////////
std::string & arda::Matrix::getstring3m(Matrix3i m, std::string & s)
   {
   s.clear();
   std::stringstream ss;
   ss << "[ "
	 "[ " << m[0] << ", " << m[1] << ", " << m[2] << " ], "
	 "[ " << m[3] << ", " << m[4] << ", " << m[5] << " ], "
	 "[ " << m[6] << ", " << m[7] << ", " << m[8] << " ] ]";
   s = ss.str();
   return s;   
   }

////////////////////////////////////////////////////////////////////////////////
std::string & arda::Matrix::getstring3m(Matrix3f m, std::string & s)
   {
   s.clear();
   std::stringstream ss;
   ss << "[ "
	 "[ " << m[0] << ", " << m[1] << ", " << m[2] << " ], "
	 "[ " << m[3] << ", " << m[4] << ", " << m[5] << " ], "
	 "[ " << m[6] << ", " << m[7] << ", " << m[8] << " ] ]";
   s = ss.str();
   return s;   
   }

////////////////////////////////////////////////////////////////////////////////
std::string & arda::Matrix::getstring3m(Matrix3d m, std::string & s)
   {
   s.clear();
   std::stringstream ss;
   ss << "[ "
	 "[ " << m[0] << ", " << m[1] << ", " << m[2] << " ], "
	 "[ " << m[3] << ", " << m[4] << ", " << m[5] << " ], "
	 "[ " << m[6] << ", " << m[7] << ", " << m[8] << " ] ]";
   s = ss.str();
   return s;   
   }

////////////////////////////////////////////////////////////////////////////////
std::string & arda::Matrix::getstring4m(Matrix4i m, std::string & s)
   {
   s.clear();
   std::stringstream ss;
   ss << "[ "
	 "[ " << m[0] << ", " << m[1] << ", " << m[2] << ", " << m[3] << " ], "
	 "[ " << m[4] << ", " << m[5] << ", " << m[6] << ", " << m[7] <<  " ], "
	 "[ " << m[8] << ", " << m[9] << ", " << m[10] << ", " << m[11] <<  " ], "
	 "[ " << m[12] << ", " << m[13] << ", " << m[14] << ", " << m[15] <<  " ] ]";
   s = ss.str();
   return s;   
   }

////////////////////////////////////////////////////////////////////////////////
std::string & arda::Matrix::getstring4m(Matrix4f m, std::string & s)
   {
   s.clear();
   std::stringstream ss;
   ss << "[ "
	 "[ " << m[0] << ", " << m[1] << ", " << m[2] << ", " << m[3] << " ], "
	 "[ " << m[4] << ", " << m[5] << ", " << m[6] << ", " << m[7] <<  " ], "
	 "[ " << m[8] << ", " << m[9] << ", " << m[10] << ", " << m[11] <<  " ], "
	 "[ " << m[12] << ", " << m[13] << ", " << m[14] << ", " << m[15] <<  " ] ]";
   s = ss.str();
   return s;   
   }

////////////////////////////////////////////////////////////////////////////////
std::string & arda::Matrix::getstring4m(Matrix4d m, std::string & s)
   {
   s.clear();
   std::stringstream ss;
   ss << "[ "
	 "[ " << m[0] << ", " << m[1] << ", " << m[2] << ", " << m[3] << " ], "
	 "[ " << m[4] << ", " << m[5] << ", " << m[6] << ", " << m[7] <<  " ], "
	 "[ " << m[8] << ", " << m[9] << ", " << m[10] << ", " << m[11] <<  " ], "
	 "[ " << m[12] << ", " << m[13] << ", " << m[14] << ", " << m[15] <<  " ] ]";
   s = ss.str();
   return s;   
   }

////////////////////////////////////////////////////////////////////////////////
int * arda::Matrix::multvec2mv(Matrix2i m, Vector2i v, Vector2i vres)
   {
   vres[0] = m[0]*v[0] + m[2]*v[1];
   vres[1] = m[1]*v[0] + m[3]*v[1];
   return vres;
   }

////////////////////////////////////////////////////////////////////////////////
float * arda::Matrix::multvec2mv(Matrix2f m, Vector2f v, Vector2f vres)
   {
   vres[0] = m[0]*v[0] + m[2]*v[1];
   vres[1] = m[1]*v[0] + m[3]*v[1];
   return vres;   
   }

////////////////////////////////////////////////////////////////////////////////
double * arda::Matrix::multvec2mv(Matrix2d m, Vector2d v, Vector2d vres)
   {
   vres[0] = m[0]*v[0] + m[2]*v[1];
   vres[1] = m[1]*v[0] + m[3]*v[1];
   return vres;
   }

////////////////////////////////////////////////////////////////////////////////
int * arda::Matrix::multvec3mv(Matrix3i m, Vector3i v, Vector3i vres)
   {
   vres[0] = m[0]*v[0] + m[3]*v[1] + m[6]*v[2];
   vres[1] = m[1]*v[0] + m[4]*v[1] + m[7]*v[2];
   vres[2] = m[2]*v[0] + m[5]*v[1] + m[8]*v[2];
   return vres;
   }

////////////////////////////////////////////////////////////////////////////////
float * arda::Matrix::multvec3mv(Matrix3f m, Vector3f v, Vector3f vres)
   {
   vres[0] = m[0]*v[0] + m[3]*v[1] + m[6]*v[2];
   vres[1] = m[1]*v[0] + m[4]*v[1] + m[7]*v[2];
   vres[2] = m[2]*v[0] + m[5]*v[1] + m[8]*v[2];
   return vres;
   }

////////////////////////////////////////////////////////////////////////////////
double * arda::Matrix::multvec3mv(Matrix3d m, Vector3d v, Vector3d vres)
   {
   vres[0] = m[0]*v[0] + m[3]*v[1] + m[6]*v[2];
   vres[1] = m[1]*v[0] + m[4]*v[1] + m[7]*v[2];
   vres[2] = m[2]*v[0] + m[5]*v[1] + m[8]*v[2];
   return vres;
   }

////////////////////////////////////////////////////////////////////////////////
int * arda::Matrix::multvec4mv(Matrix4i m, Vector4i v, Vector4i vres)
   {
   vres[0] = m[0]*v[0] + m[4]*v[1] + m[8] *v[2] + m[12]*v[3];
   vres[1] = m[1]*v[0] + m[5]*v[1] + m[9]*v[2]  + m[13]*v[3];
   vres[2] = m[2]*v[0] + m[6]*v[1] + m[10]*v[2] + m[14]*v[3];
   vres[3] = m[3]*v[0] + m[7]*v[1] + m[11]*v[2] + m[15]*v[3];
   return vres;
   }

////////////////////////////////////////////////////////////////////////////////
float * arda::Matrix::multvec4mv(Matrix4f m, Vector4f v, Vector4f vres)
   {
   vres[0] = m[0]*v[0] + m[4]*v[1] + m[8] *v[2] + m[12]*v[3];
   vres[1] = m[1]*v[0] + m[5]*v[1] + m[9]*v[2]  + m[13]*v[3];
   vres[2] = m[2]*v[0] + m[6]*v[1] + m[10]*v[2] + m[14]*v[3];
   vres[3] = m[3]*v[0] + m[7]*v[1] + m[11]*v[2] + m[15]*v[3];
   return vres;
  
   }

////////////////////////////////////////////////////////////////////////////////
double * arda::Matrix::multvec4mv(Matrix4d m, Vector4d v, Vector4d vres)
   {
   vres[0] = m[0]*v[0] + m[4]*v[1] + m[8] *v[2] + m[12]*v[3];
   vres[1] = m[1]*v[0] + m[5]*v[1] + m[9]*v[2]  + m[13]*v[3];
   vres[2] = m[2]*v[0] + m[6]*v[1] + m[10]*v[2] + m[14]*v[3];
   vres[3] = m[3]*v[0] + m[7]*v[1] + m[11]*v[2] + m[15]*v[3];
   return vres;
   }

////////////////////////////////////////////////////////////////////////////////
int * arda::Matrix::multvec2vm(Vector2i v, Matrix2i m, Vector2i vres)
   {
   vres[0] = v[0]*m[0] + v[1]*m[1];
   vres[1] = v[0]*m[2] + v[1]*m[3];
   return vres;   
   }

////////////////////////////////////////////////////////////////////////////////
float * arda::Matrix::multvec2vm(Vector2f v, Matrix2f m, Vector2f vres)
   {
   vres[0] = v[0]*m[0] + v[1]*m[1];
   vres[1] = v[0]*m[2] + v[1]*m[3];
   return vres;   
   }

////////////////////////////////////////////////////////////////////////////////
double * arda::Matrix::multvec2vm(Vector2d v, Matrix2d m, Vector2d vres)
   {
   vres[0] = v[0]*m[0] + v[1]*m[1];
   vres[1] = v[0]*m[2] + v[1]*m[3];
   return vres;   
   }

////////////////////////////////////////////////////////////////////////////////
int * arda::Matrix::multvec3vm(Vector3i v, Matrix3i m, Vector3i vres)
   {
   vres[0] = v[0]*m[0] + v[1]*m[1] + v[2]*m[2];
   vres[1] = v[0]*m[3] + v[1]*m[4] + v[2]*m[5];
   vres[2] = v[0]*m[6] + v[1]*m[7] + v[2]*m[8];
   return vres;   
   }

////////////////////////////////////////////////////////////////////////////////
float * arda::Matrix::multvec3vm(Vector3f v, Matrix3f m, Vector3f vres)
   {
   vres[0] = v[0]*m[0] + v[1]*m[1] + v[2]*m[2];
   vres[1] = v[0]*m[3] + v[1]*m[4] + v[2]*m[5];
   vres[2] = v[0]*m[6] + v[1]*m[7] + v[2]*m[8];
   return vres;   
   }

////////////////////////////////////////////////////////////////////////////////
double * arda::Matrix::multvec3vm(Vector3d v, Matrix3d m, Vector3d vres)
   {
   vres[0] = v[0]*m[0] + v[1]*m[1] + v[2]*m[2];
   vres[1] = v[0]*m[3] + v[1]*m[4] + v[2]*m[5];
   vres[2] = v[0]*m[6] + v[1]*m[7] + v[2]*m[8];
   return vres;   
   }

////////////////////////////////////////////////////////////////////////////////
int * arda::Matrix::multvec4vm(Vector4i v, Matrix4i m, Vector4i vres)
   {
   vres[0] = v[0]*m[0]  + v[1]*m[1]  + v[2]*m[2]  + v[3]*m[3];
   vres[1] = v[0]*m[4]  + v[1]*m[5]  + v[2]*m[6]  + v[3]*m[7];
   vres[2] = v[0]*m[8]  + v[1]*m[9]  + v[2]*m[10] + v[3]*m[11];
   vres[3] = v[0]*m[12] + v[1]*m[13] + v[2]*m[14] + v[3]*m[15];
   return vres;   
   }

////////////////////////////////////////////////////////////////////////////////
float * arda::Matrix::multvec4vm(Vector4f v, Matrix4f m, Vector4f vres)
   {
   vres[0] = v[0]*m[0]  + v[1]*m[1]  + v[2]*m[2]  + v[3]*m[3];
   vres[1] = v[0]*m[4]  + v[1]*m[5]  + v[2]*m[6]  + v[3]*m[7];
   vres[2] = v[0]*m[8]  + v[1]*m[9]  + v[2]*m[10] + v[3]*m[11];
   vres[3] = v[0]*m[12] + v[1]*m[13] + v[2]*m[14] + v[3]*m[15];
   return vres;   
   }

////////////////////////////////////////////////////////////////////////////////
double * arda::Matrix::multvec4vm(Vector4d v, Matrix4d m, Vector4d vres)
   {
   vres[0] = v[0]*m[0]  + v[1]*m[1]  + v[2]*m[2]  + v[3]*m[3];
   vres[1] = v[0]*m[4]  + v[1]*m[5]  + v[2]*m[6]  + v[3]*m[7];
   vres[2] = v[0]*m[8]  + v[1]*m[9]  + v[2]*m[10] + v[3]*m[11];
   vres[3] = v[0]*m[12] + v[1]*m[13] + v[2]*m[14] + v[3]*m[15];
   return vres;   
   }


////////////////////////////////////////////////////////////////////////////////
int * arda::Matrix::multmat2(Matrix2i m1, Matrix2i m2, Matrix2i mres)
   {
   const int size=2;
   int i, j, k;
   for (i=0; i<size*size; ++i)
      mres[i] = 0;
   for (i=0; i<size; ++i)
      for (j=0; j<size; ++j)
	 for (k=0; k<size; ++k)
	    mres[size*i+j] += m1[size*k+j] * m2[size*i+k];
   return mres;
   }

////////////////////////////////////////////////////////////////////////////////
float * arda::Matrix::multmat2(Matrix2f m1, Matrix2f m2, Matrix2f mres)
   {
   const int size=2;
   int i, j, k;
   for (i=0; i<size*size; ++i)
      mres[i] = 0;
   for (i=0; i<size; ++i)
      for (j=0; j<size; ++j)
	 for (k=0; k<size; ++k)
	    mres[size*i+j] += m1[size*k+j] * m2[size*i+k];
   return mres;
   }

////////////////////////////////////////////////////////////////////////////////
double * arda::Matrix::multmat2(Matrix2d m1, Matrix2d m2, Matrix2d mres)
   {
   const int size=2;
   int i, j, k;
   for (i=0; i<size*size; ++i)
      mres[i] = 0;
   for (i=0; i<size; ++i)
      for (j=0; j<size; ++j)
	 for (k=0; k<size; ++k)
	    mres[size*i+j] += m1[size*k+j] * m2[size*i+k];
   return mres;
   }

////////////////////////////////////////////////////////////////////////////////
int * arda::Matrix::multmat3(Matrix3i m1, Matrix3i m2, Matrix3i mres)
   {
   const int size=3;
   int i, j, k;
   for (i=0; i<size*size; ++i)
      mres[i] = 0;
   for (i=0; i<size; ++i)
      for (j=0; j<size; ++j)
	 for (k=0; k<size; ++k)
	    mres[size*i+j] += m1[size*k+j] * m2[size*i+k];
   return mres;
   }

////////////////////////////////////////////////////////////////////////////////
float * arda::Matrix::multmat3(Matrix3f m1, Matrix3f m2, Matrix3f mres)
   {
   const int size=3;
   int i, j, k;
   for (i=0; i<size*size; ++i)
      mres[i] = 0;
   for (i=0; i<size; ++i)
      for (j=0; j<size; ++j)
	 for (k=0; k<size; ++k)
	    mres[size*i+j] += m1[size*k+j] * m2[size*i+k];
   return mres;
   }

////////////////////////////////////////////////////////////////////////////////
double * arda::Matrix::multmat3(Matrix3d m1, Matrix3d m2, Matrix3d mres)
   {
   const int size=3;
   int i, j, k;
   for (i=0; i<size*size; ++i)
      mres[i] = 0;
   for (i=0; i<size; ++i)
      for (j=0; j<size; ++j)
	 for (k=0; k<size; ++k)
	    mres[size*i+j] += m1[size*k+j] * m2[size*i+k];
   return mres;
   }

////////////////////////////////////////////////////////////////////////////////
int * arda::Matrix::multmat4(Matrix4i m1, Matrix4i m2, Matrix4i mres)
   {
   const int size=4;
   int i, j, k;
   for (i=0; i<size*size; ++i)
      mres[i] = 0;
   for (i=0; i<size; ++i)
      for (j=0; j<size; ++j)
	 for (k=0; k<size; ++k)
	    mres[size*i+j] += m1[size*k+j] * m2[size*i+k];
   return mres;
   }

////////////////////////////////////////////////////////////////////////////////
float * arda::Matrix::multmat4(Matrix4f m1, Matrix4f m2, Matrix4f mres)
   {
   const int size=4;
   int i, j, k;
   for (i=0; i<size*size; ++i)
      mres[i] = 0;
   for (i=0; i<size; ++i)
      for (j=0; j<size; ++j)
	 for (k=0; k<size; ++k)
	    mres[size*i+j] += m1[size*k+j] * m2[size*i+k];
   return mres;
   }

////////////////////////////////////////////////////////////////////////////////
double * arda::Matrix::multmat4(Matrix4d m1, Matrix4d m2, Matrix4d mres)
   {
   cout << "here" << endl;
   const int size=4;
   int i, j, k;
   for (i=0; i<size*size; ++i)
      mres[i] = 0;
   for (i=0; i<size; ++i)
      for (j=0; j<size; ++j)
	 for (k=0; k<size; ++k)
	    mres[size*i+j] += m1[size*k+j] * m2[size*i+k];
   return mres;
   }

////////////////////////////////////////////////////////////////////////////////
int * arda::Matrix::transpose2(Matrix2i m, Matrix2i mres)
   {
   const int size=2;
   int i, j;
   for (i=0; i<size; ++i)
      for (j=0; j<size; j++)
	 mres[size*i+j] = m[size*j+i];
   return mres;
   }

////////////////////////////////////////////////////////////////////////////////
float * arda::Matrix::transpose2(Matrix2f m, Matrix2f mres)
   {
   const int size=2;
   int i, j;
   for (i=0; i<size; ++i)
      for (j=0; j<size; j++)
	 mres[size*i+j] = m[size*j+i];
   return mres;
   }

////////////////////////////////////////////////////////////////////////////////
double * arda::Matrix::transpose2(Matrix2d m, Matrix2d mres)
   {
   const int size=2;
   int i, j;
   for (i=0; i<size; ++i)
      for (j=0; j<size; j++)
	 mres[size*i+j] = m[size*j+i];
   return mres;
   }

////////////////////////////////////////////////////////////////////////////////
int * arda::Matrix::transpose3(Matrix3i m, Matrix3i mres)
   {
   const int size=3;
   int i, j;
   for (i=0; i<size; ++i)
      for (j=0; j<size; j++)
	 mres[size*i+j] = m[size*j+i];
   return mres;
   }

////////////////////////////////////////////////////////////////////////////////
float * arda::Matrix::transpose3(Matrix3f m, Matrix3f mres)
   {
   const int size=3;
   int i, j;
   for (i=0; i<size; ++i)
      for (j=0; j<size; j++)
	 mres[size*i+j] = m[size*j+i];
   return mres;
   }

////////////////////////////////////////////////////////////////////////////////
double * arda::Matrix::transpose3(Matrix3d m, Matrix3d mres)
   {
   const int size=3;
   int i, j;
   for (i=0; i<size; ++i)
      for (j=0; j<size; j++)
	 mres[size*i+j] = m[size*j+i];
   return mres;
   }

////////////////////////////////////////////////////////////////////////////////
int * arda::Matrix::transpose4(Matrix4i m, Matrix4i mres)
   {
   const int size=4;
   int i, j;
   for (i=0; i<size; ++i)
      for (j=0; j<size; j++)
	 mres[size*i+j] = m[size*j+i];
   return mres;
   }

////////////////////////////////////////////////////////////////////////////////
float * arda::Matrix::transpose4(Matrix4f m, Matrix4f mres)
   {
   const int size=4;
   int i, j;
   for (i=0; i<size; ++i)
      for (j=0; j<size; j++)
	 mres[size*i+j] = m[size*j+i];
   return mres;
   }

////////////////////////////////////////////////////////////////////////////////
double * arda::Matrix::transpose4(Matrix4d m, Matrix4d mres)
   {
   const int size=4;
   int i, j;
   for (i=0; i<size; ++i)
      for (j=0; j<size; j++)
	 mres[size*i+j] = m[size*j+i];
   return mres;
   }


